"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getDeclarationsForTypes(contracts, types) {
    let result = {};
    for (let contract of contracts) {
        if (contract) {
            for (const node of contract.nodes) {
                if (types.includes(node.nodeType)) {
                    result[node.id] = node;
                }
            }
        }
    }
    return result;
}
function getReferenceDeclarations(contracts) {
    const types = [
        "EnumDefinition",
        "StructDefinition",
    ];
    let contractsObject = Object.assign({}, ...contracts.map((node) => ({ [node.id]: node })));
    return Object.assign({}, getDeclarationsForTypes(contracts, types), contractsObject);
}
exports.getReferenceDeclarations = getReferenceDeclarations;
function getEventDefinitions(contracts) {
    const types = [
        "EventDefinition"
    ];
    return getDeclarationsForTypes(contracts, types);
}
exports.getEventDefinitions = getEventDefinitions;
//# sourceMappingURL=general.js.map